// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 57 1.6.1.4 source/core/collect/iimapdil.h, collection, ioc.v400, 001006 
#ifndef _IIMAPDIL_
#define _IIMAPDIL_

#include <iimapks.h>
#include <iiksdil.h>







#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)










#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

typedef IMapOnKeySetImpl
         <IKeySetAsDilTableImpl> IMapAsDilTableImpl;

typedef IAMapOnKeySetOps
         <IKeySetAsDilTableImpl> IAMapAsAsDilTableOps;

#pragma pack(push,4)
#pragma enum(4)

template <class Element, class _Key,
          class ElementOps, class Implementation>
class IC_EXPORTC IMapAsDilTableOps :
  public IAMapAsAsDilTableOps {

  typedef  IMapAsDilTableOps
            <Element, _Key, ElementOps, Implementation> Self;

  typedef  IKeySetAsDilTableOps
            <Element, _Key,
             ElementOps, IKeySetAsDilTableImpl> Base;

public:

  typedef  Implementation ImplType;

  typedef  Element ElementType;

  typedef  _Key KeyType;

           IMapAsDilTableOps
                           (INumber);

           IMapAsDilTableOps
                           (INumber, void*);

           IMapAsDilTableOps
                           (IMapAsDilTableOps
                             <Element, _Key,
                              ElementOps, Implementation> const&);

          ~IMapAsDilTableOps
                           ();

  IACollectionImpl*
           Clone           () const;

  bool     EqualElements    (void const*, void const*) const;

           operator IKeySetAsDilTableImpl&
                           ();

           operator Implementation*
                           ();


















protected:

private:

  ElementOps
           ivElementOps;
 
  Base     ivBase;

  Implementation
           ivImpl;












};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif








#if ! defined (__TEMPINC__)
#include <iimapdil.c>
#endif



#pragma info (restore)


#endif // _IIMAPDIL_
