// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 60 1.6.1.4 source/core/collect/iimaphsh.h, collection, ioc.v400, 001006 
#ifndef _IIMAPHSH_
#define _IIMAPHSH_

#include <iimapks.h>
#include <iikshsh.h>







#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)










#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

typedef IMapOnKeySetImpl
         <IKeySetAsHshTableImpl> IMapAsHshTableImpl;

typedef IAMapOnKeySetOps
         <IKeySetAsHshTableImpl> IAMapAsAsHshTableOps;

#pragma pack(push,4)
#pragma enum(4)

template <class Element, class _Key,
          class ElementOps, class Implementation>
class IC_EXPORTC IMapAsHshTableOps :
  public IAMapAsAsHshTableOps {

  typedef  IMapAsHshTableOps
            <Element, _Key, ElementOps, Implementation> Self;

  typedef  IKeySetAsHshTableOps
            <Element, _Key,
             ElementOps, IKeySetAsHshTableImpl> Base;

public:

  typedef  Implementation ImplType;

  typedef  Element ElementType;

  typedef  _Key KeyType;

           IMapAsHshTableOps
                           (INumber);

           IMapAsHshTableOps
                           (INumber, void*);

           IMapAsHshTableOps
                           (IMapAsHshTableOps
                             <Element, _Key,
                              ElementOps, Implementation> const&);

          ~IMapAsHshTableOps
                           ();

  IACollectionImpl*
           Clone           () const;

  bool     EqualElements    (void const*, void const*) const;

           operator IKeySetAsHshTableImpl&
                           ();

           operator Implementation*
                           ();


















protected:

private:

  ElementOps
           ivElementOps;
 
  Base     ivBase;

  Implementation
           ivImpl;












};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif








#if ! defined (__TEMPINC__)
#include <iimaphsh.c>
#endif



#pragma info (restore)


#endif // _IIMAPHSH_
