// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 88 1.6.1.4 source/core/collect/iireltab.h, collection, ioc.v400, 001006 
#ifndef _IIRELTAB_
#define _IIRELTAB_

#include <iirelkb.h>
#include <iikbtab.h>







#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)










#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

typedef IRelationOnKeyBagImpl
         <IKeyBagAsTableImpl> IRelationAsTableImpl;

#pragma pack(push,4)
#pragma enum(4)

template <class Element, class _Key,
          class ElementOps, class Implementation>
class IC_EXPORTC IRelationAsTableOps :
  public IARelationOnKeyBagOps
          <IKeyBagAsTableImpl> {

  typedef  IRelationAsTableOps
            <Element, _Key, ElementOps, Implementation> Self;

  typedef  IKeyBagAsTableOps
            <Element, _Key,
             ElementOps, IKeyBagAsTableImpl> Base;

public:

  typedef  Implementation ImplType;

  typedef  Element ElementType;

  typedef  _Key KeyType;

           IRelationAsTableOps
                           (INumber);

           IRelationAsTableOps
                           (INumber, void*);

           IRelationAsTableOps
                           (IRelationAsTableOps
                             <Element, _Key,
                              ElementOps, Implementation> const&);

          ~IRelationAsTableOps
                           ();

  IACollectionImpl*
           Clone           () const;

  bool     EqualElements   (void const*, void const*) const;

           operator IKeyBagAsTableImpl&
                           ();

           operator Implementation*
                           ();


















protected:

private:

  ElementOps
           ivElementOps;
 
  Base     ivBase;

  Implementation
           ivImpl;












};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif








#if ! defined (__TEMPINC__)
#include <iireltab.c>
#endif



#pragma info (restore)


#endif // _IIRELTAB_
