// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 33 1.6.1.4 source/core/collect/iisettab.h, collection, ioc.v400, 001006 
#ifndef _IISETTAB_
#define _IISETTAB_

#include <iisetks.h>
#include <iikstab.h>







#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)










#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

typedef ISetOnKeySetImpl
         <IKeySetAsTableImpl> ISetAsTableImpl;

#pragma pack(push,4)
#pragma enum(4)

template <class Element, class ElementOps, class Implementation>
class IC_EXPORTC ISetAsTableOps :
  public IASetOnKeySetOps <IKeySetAsTableImpl> {

  typedef  ISetAsTableOps
            <Element, ElementOps, Implementation> Self;

  typedef  IKeySetAsTableOps
            <Element, Element, IOpsWithKey <Element, ElementOps>,
             IKeySetAsTableImpl> Base;

public:

  typedef  Implementation ImplType;

  typedef  Element ElementType;

  typedef  void KeyType;

           ISetAsTableOps
                           (INumber);

           ISetAsTableOps
                           (INumber, void*);

           ISetAsTableOps
                           (ISetAsTableOps
                             <Element, ElementOps,
                              Implementation> const&);

          ~ISetAsTableOps
                           ();

  IACollectionImpl*
           Clone           () const;

           operator IKeySetAsTableImpl&
                           ();

           operator Implementation*
                           ();


















protected:

private:

  Base     ivBase;

  Implementation
           ivImpl;












};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif








#if ! defined (__TEMPINC__)
#include <iisettab.c>
#endif



#pragma info (restore)


#endif // _IISETTAB_
