#ifndef __nl_types_h

   #if __IBMC__ || __IBMCPP__
      #pragma info( none )
      #ifndef __CHKHDR__
         #pragma info( none )
      #endif
      #pragma info( restore )
   #endif

   #define __nl_types_h

   #ifdef __cplusplus
      extern "C" {
   #endif

   #ifndef  _LNK_CONV
      #ifdef __THW_INTEL__
         #define _LNK_CONV _Optlink
      #else
         #define _LNK_CONV
      #endif
   #endif

   #ifndef _IMPORT
      #ifdef __IMPORTLIB__
         #define _IMPORT _Import
      #else
         #define _IMPORT
      #endif
   #endif

   /********************************************************************/
   /*  <builtin.h> Header File                                         */
   /*  IBM C and C++ Compilers for OS/2, AIX and for Windows NT,       */
   /*  Version 3.6                                                     */
   /*  Licensed Material - Property of IBM                             */
   /*  (C) Copyright IBM Corp. 1991, 1997. All rights reserved         */
   /*                                                                  */
   /********************************************************************/

   typedef struct __file FILE;

   struct _catalog_descriptor {
      char            *_mem;
      char            *_name;
      FILE            *_fd;
      struct _header  *_hd;
      struct _catset  *_set;
      int             _setmax;
      int             _count;
      int             _pid;
      int             _oflag;
   };

   typedef int nl_item;

   typedef struct _catalog_descriptor *nl_catd;

   #define NL_SETD         1
   #define NL_CAT_LOCALE   1

   #define CAT_MAGIC       505
   #define CATD_ERR        ((nl_catd) -1)
   #define NL_MAXOPEN      10

   extern int      _IMPORT _LNK_CONV catclose( nl_catd );
   extern char    *_IMPORT _LNK_CONV catgets( nl_catd, int, int, const char* );
   extern nl_catd  _IMPORT _LNK_CONV catopen( const char*, int );

   #ifdef __cplusplus
      }
   #endif

   #if __IBMC__ || __IBMCPP__
      #pragma info( none )
      #ifndef __CHKHDR__
         #pragma info( restore )
      #endif
      #pragma info( restore )
   #endif

#endif

